/*

	MySpots screen blanker.
	
	Based on Be example code /optional/sample-code/screen_savers/Spots

	It's my first stumbling steps with Be programming,	
	thus I might do taboo/stupid things without knowing it.

	On top of that I'm not used to C++, I've been programming in C
	for some years, and my mind is not quite Object Oriented yet.

	Please forgive me,
	
		Urban Lindeskog (ubbe@rit.se)
*/
#include "MySpots.h"
#include <StringView.h>
#include <stdlib.h>

extern "C" _EXPORT BScreenSaver *instantiate_screen_saver(BMessage *message, image_id image)
{
	return new MySpots(message, image);
}

MySpots::MySpots(BMessage *message, image_id image)
 : BScreenSaver(message, image)
{
}

void MySpots::StartConfig(BView *view)
{
// There must be a nicer way to do this, wrt font size etc.
// But it's just a stupid about text, so I skip it for now.
	view->AddChild(new BStringView(BRect(10, 10, 200, 35), NULL, "MySpots, shapes on the desktop."));
	view->AddChild(new BStringView(BRect(10, 40, 200, 65), NULL, "Based on Be sample code (thanks),"));
	view->AddChild(new BStringView(BRect(10, 70, 200, 95), NULL, "by Urban Lindeskog."));
}

status_t MySpots::StartSaver(BView *, bool preview)
{
// Hey, might do something with the preview bool, instead of
// the stupid check of the view size to render appropiatly sized shapes
// for the preview in Preferences/ScreenSaver
//
// ...Writing this excuse might have taken me longer time than to actually do it.
// Wait a minute, I'll leave it to the reader to fix it!

	SetTickSize(50000);
	return B_OK;
}

void MySpots::Draw(BView *view, int32)
{
	int			intensity=255, size=30, hize=15, counter;
	BRect		r, rr;
	BPoint		belogo[16];

	unsigned char 	points[32]={0,40,     30,0,   80,0,  120,40,
								120,35,  90,65,  60,80,   20,55,
								20,60,   45,20, 130,30,  80,110,
								80,105, 95,155, 50,160,  40,135};

	// Here's the stupid check for preview in Preferences/ScreenSaver.
	// But, on the other hand, if you have such a small display, you
	// might appreciate this too...
	if((view->Bounds().IntegerHeight()) < 255)
		{
		size=((rand()%10))+1;
		hize=(size/2)+1;
		}
	else
		{
		size=(rand()%100);
		hize=(size/2)+1;
		}
		
	r.top = (rand() % (view->Bounds().IntegerHeight())) - hize;
	r.left = (rand() % (view->Bounds().IntegerWidth())) - hize;
	r.bottom = r.top + size;
	r.right = r.left + size;

	view->SetLowColor(rand()%intensity, rand()%intensity, rand()%intensity, 255);

	switch(rand() % 8)
		{
		case 0:
		view->FillRoundRect(r, hize, hize, B_SOLID_LOW);
		break;
		
		case 1:
		view->FillTriangle(BPoint(r.left, r.top), BPoint(r.left+hize, r.top+size), BPoint(r.left+size, r.top), B_SOLID_LOW);
		break;

		case 2:
		view->FillTriangle(BPoint(r.left, r.top), BPoint(r.left, r.top+size), BPoint(r.left+size, r.top+hize), B_SOLID_LOW);
		break;

		case 3:
		view->FillTriangle(BPoint(r.left, r.top+hize), BPoint(r.left+size, r.top+size), BPoint(r.left+size, r.top), B_SOLID_LOW);
		break;

		case 4:
		view->FillTriangle(BPoint(r.left, r.top+size), BPoint(r.left+size, r.top+size), BPoint(r.left+hize, r.top), B_SOLID_LOW);
		break;

		case 5:
		view->FillRect(r, B_SOLID_LOW);
		break;

		case 6:
		rr.top		= r.top - (hize/2);
		rr.left		= r.left - (hize/2);
		rr.bottom	= rr.top + (size/10);
		rr.right	= rr.left + (size/10);

		view->SetLowColor(255, 255, 0, 255);
		view->FillArc(BPoint(r.left, r.top), hize, hize, 45, 270, B_SOLID_LOW);

		view->SetLowColor(190, 190, 0, 255);
		view->StrokeArc(BPoint(r.left, r.top), hize, hize, 45, 270, B_SOLID_LOW);

		view->SetLowColor(0, 0, 0, 255);
		view->FillRoundRect(rr, hize/10, hize/10, B_SOLID_LOW);

		rr.bottom	= rr.top + (size/20);
		rr.right	= rr.left + (size/20);
		view->SetLowColor(255, 255, 255, 255);
		view->FillRoundRect(rr, hize/20, hize/20, B_SOLID_LOW);
		break;

		case 7:
		// You could scale the splines your self, but I wanted to try
		// the system scaling.
		//
		// OK!...I admit, I was too lazy. But on the other hand, what do
		// you have an operating system for?
		//
		// And, what an Operating System we've got here...
		// I've got those warm and fuzzy feelings, as with my first Amiga.
		// Hope we'll stay clear of those mindless zealots, CrAcKeRz and
		// HW bangers this time.
		float	scales[5]={0.0625, 0.125, 0.25, 0.5, 1.0};
		int		ratios[5]={16, 8, 4, 2, 1};

		// Here's the stupid check for preview in Preferences/ScreenSaver. -Again!
		if((view->Bounds().IntegerHeight()) < 255)
			{
			counter=0;
			}
		else
			{
			counter=rand()%5;
			}

		view->SetScale(scales[counter]);
		size=200;
		hize=100;
		r.top = (rand() % ((view->Bounds().IntegerHeight())*ratios[counter])) - hize;
		r.left = (rand() % ((view->Bounds().IntegerWidth())*ratios[counter])) - hize;	
		r.bottom = r.top + size;
		r.right = r.left + size;

		view->SetLowColor(255, 0, 0, 255);
		view->FillRoundRect(r, hize/4, hize/4, B_SOLID_LOW);

		for(counter=0; counter<16; counter++)
			{
			belogo[counter]=BPoint(
									r.left+40+points[counter*2],
									r.top+20+points[counter*2+1]
								  );
			}

		view->SetPenSize(12);
		view->SetLowColor(255, 255, 255, 255);
		view->StrokeBezier(&belogo[0], B_SOLID_LOW);
		view->StrokeBezier(&belogo[4], B_SOLID_LOW);
		view->StrokeBezier(&belogo[8], B_SOLID_LOW);
		view->StrokeBezier(&belogo[12], B_SOLID_LOW);
		view->SetPenSize(1);

		view->SetScale(1.0);
		break;
		}
}
